/*******************************************************************************
 * FoxWeapon_DeployableTurret generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_DeployableTurret extends FoxWeapon_DeployableBase
    native(Weapon)
    config(DeployableAI)
    hidecategories(Navigation);

var private string DeployActorClassName;

simulated event PostBeginPlay()
{
    DeployActorClass = class<FoxPawn_DeployableTurret>(class'FoxLoadoutInfo'.static.ResolveCharContentByName(DeployActorClassName));
    super.PostBeginPlay();
    //return;    
}

function SpawnDeployable(Vector DesiredLocation, Rotator DesiredRotation)
{
    local FoxAIControllerInterface NewController;
    local FoxPawn_DeployableTurret Turret;
    local class<FoxPawn_DeployableTurret> TurretClass;
    local Vector ModifiedLocation;

    AmmoUsedCount = int(GetMagazineSize());
    SimulatedAmmoUsedCount = AmmoUsedCount;
    AmmoLeftCount = 0;
    ModifiedLocation = Instigator.Location + QuatRotateVector(QuatFromRotator(Instigator.Rotation), vect(100.0, 0.0, 0.0));
    NewController = Spawn(class'FoxAIControllerInterface_Turret', none,, ModifiedLocation, Instigator.Rotation,, true);
    // End:0xF6
    if(NewController == none)
    {
        return;
    }
    TurretClass = class<FoxPawn_DeployableTurret>(DeployActorClass);
    Turret = Spawn(TurretClass, NewController,, ModifiedLocation, Instigator.Rotation,, true);
    // End:0x173
    if(Turret == none)
    {
        return;
    }
    Turret.SetPhysics(2);
    Turret.Health -= UsedHealth;
    NewController.PlayerReplicationInfo.SquadIdx = Instigator.GetTeamNum();
    FoxGame(WorldInfo.Game).PerformTeamSwitch(NewController, Instigator.GetTeamNum());
    // End:0x295
    if(FoxPawn(Instigator) != none)
    {
        KillOtherDeployablesByInstigator();
    }
    Turret.OwningPlayerPRI = FoxPRI(Instigator.PlayerReplicationInfo);
    Turret.OwningPlayerPRI_ID = FoxPRI(Instigator.PlayerReplicationInfo).PlayerID;
    Turret.OwningPlayer = FoxPC(Instigator.Controller);
    NewController.Possess(Turret, false);
    //return;    
}

defaultproperties
{
    begin object name=TestMesh0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeapon_DeployableTurret.TestMesh0'
    DeployableTestMesh=TestMesh0
    TestMIC=MaterialInstanceConstant'Default__FoxWeapon_DeployableTurret.TestMIC0'
    begin object name=HaloComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxWeapon_DeployableTurret.HaloComp'
    DeployableHalo=HaloComp
    bIsDepotWeapon=true
    bSupportsBarrelMods=false
    bSupportsMagazineMods=false
    bSupportsMuzzleMods=false
    bSupportsStockMods=false
    bSupportsGripMods=false
    WeaponType=EWeaponType.WT_Secondary
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_DeployableTurret.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_DeployableTurret.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_DeployableTurret.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_DeployableTurret.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.10351880
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_DeployableTurret.LensComp'
    MuzzleLensFlare=LensComp
    FiringStatesArray=/* Array type was not detected. */
    bInstantHit=true
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_DeployableTurret.WeaponMesh'
    Mesh=WeaponMesh
    begin object name=TestMesh0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeapon_DeployableTurret.TestMesh0'
    Components(0)=TestMesh0
    begin object name=HaloComp class=ParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxWeapon_DeployableTurret.HaloComp'
    Components(1)=HaloComp
}